#include "common.h"
#include "node_api.h"

static napi_value create_symbol(napi_env env, napi_callback_info info) {
  size_t argc = 1;
  napi_value args[1];
  NAPI_CALL(env, napi_get_cb_info(env, info, &argc, args, NULL, NULL));

  napi_value description = NULL;
  if (argc >= 1) {
    napi_valuetype valuetype;
    NAPI_CALL(env, napi_typeof(env, args[0], &valuetype));

    NAPI_ASSERT(env, valuetype == napi_string,
                "Wrong type of arguments. Expects a string.");

    description = args[0];
  }

  napi_value symbol;
  NAPI_CALL(env, napi_create_symbol(env, description, &symbol));

  return symbol;
}

static napi_value Init(napi_env env, napi_value exports) {
  napi_property_descriptor properties[] = {
    DECLARE_NAPI_PROPERTY("CreateSymbol", create_symbol),
  };

  NAPI_CALL(env, napi_define_properties(env, exports, sizeof(properties) /
                                                          sizeof(*properties),
                                        properties));

  return exports;
}

NAPI_MODULE(NODE_GYP_MODULE_NAME, Init)
